<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-8 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6 text-center"
          >
          Información de Aspirantes
          </div>
        </q-card-section>
        <q-card-section>
          <q-table
            class="my-table"
            :data="form"
            :columns="columns"
            row-key="name"
            :filter="filter"
            >
              <template v-slot:top-right>
              <q-input borderless dense debounce="300" v-model="filter" placeholder="Buscar">
                <template v-slot:append>
                  <q-icon name="search" />
                </template>
              </q-input>
            </template>
             <template v-slot:body="props">
              <q-tr :props="props">
                <q-td key="name" :props="props">
                  {{ props.row.name }}
                </q-td>
                <q-td key="carrera" :props="props">
                  {{ props.row.carrera }}
                </q-td>
                <q-td key="actions" :props="props">
                  <q-btn
                    v-for="action in props.row.actions"
                    :key="action.icon"
                    :icon="action.icon"
                    :to="action.url"
                    :color="action.color"
                    flat
                    dense
                  >
                    <q-tooltip  content-class="bg-white text-black shadow-4" :offset="[10, 10]">
                      {{action.title}}
                    </q-tooltip>
                  </q-btn>
                </q-td>
              </q-tr>
            </template>
          </q-table>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<style lang="sass" scoped>
.my-tablet
  height: 310px

  .q-table_top,
  .q-table_bottom,
  thead tr:first-child th
    background-color: #c1f4c1

  thead tr th
    position: sticky
    z-index: 1
  thead tr:first-child th
    top: 0

  &.q-table--loading thead tr:last-child th
    top: 48px
</style>
<script>
import { mapGetters } from 'vuex'
export default {
  data () {
    return {
      form: [],
      filter: '',
      copyForm: [],
      columns: [
        {
          name: 'name',
          align: 'left',
          field: 'name',
          label: 'Nombre',
          sortable: true
        },
        {
          name: 'carrera',
          align: 'left',
          field: 'Carrera',
          label: 'Carrera',
          sortable: true
        },
        { name: 'actions', required: true, label: 'Acciones', align: 'left', field: 'actions', sortable: true }
      ]
    }
  },
  computed: {
    ...mapGetters('generals', ['student'])
  },
  mounted () {
    if (this.student === 'admin' || this.student === 'studiantil_service' || this.student === 'control') {
      this.getBack()
    } else {
      this.getFilter()
    }
  },
  methods: {
    getFilter () {
      this.$q.loading.show()
      this.$api.get('GetStudents_Documents_Filter/' + this.student).then(res => {
        this.form = res
        this.$q.loading.hide()
      })
    },
    getBack () {
      this.$q.loading.show()
      this.$api.get('GetStudents_Documents').then(res => {
        this.form = res
        this.$q.loading.hide()
      })
    }
  }
}
</script>
